Index: palm/trunk/SOURCE/data_output_module.f90
===================================================================
--- palm/trunk/SOURCE/data_output_module.f90	(revision 4596)
+++ palm/trunk/SOURCE/data_output_module.f90	(revision 4597)
@@ -24,4 +24,9 @@
 ! -----------------
 ! $Id$
+! bugfix: - write unlimited dimension in netcdf4-parallel mode
+! new   : - added optional argument to dom_def_dim to allow that dimension variables can be written
+!           by every PE
+!
+! 4579 2020-06-25 20:05:07Z gronemeier
 ! corrected formatting to follow PALM coding standard
 !
@@ -116,21 +121,22 @@
 
     TYPE variable_type
-       CHARACTER(LEN=charlen)                            ::  data_type = ''       !< data type
-       CHARACTER(LEN=charlen)                            ::  name                 !< variable name
-       INTEGER                                           ::  id = no_id           !< id within file
-       LOGICAL                                           ::  is_global = .FALSE.  !< true if global variable
-       CHARACTER(LEN=charlen), DIMENSION(:), ALLOCATABLE ::  dimension_names      !< list of dimension names used by variable
-       INTEGER,                DIMENSION(:), ALLOCATABLE ::  dimension_ids        !< list of dimension ids used by variable
-       TYPE(attribute_type),   DIMENSION(:), ALLOCATABLE ::  attributes           !< list of attributes
+       CHARACTER(LEN=charlen) ::  data_type = ''                              !< data type
+       CHARACTER(LEN=charlen) ::  name                                        !< variable name
+       INTEGER                ::  id = no_id                                  !< id within file
+       LOGICAL                ::  write_only_by_master_rank = .FALSE.         !< true if only master rank shall write variable
+       CHARACTER(LEN=charlen), DIMENSION(:), ALLOCATABLE ::  dimension_names  !< list of dimension names used by variable
+       INTEGER,                DIMENSION(:), ALLOCATABLE ::  dimension_ids    !< list of dimension ids used by variable
+       TYPE(attribute_type),   DIMENSION(:), ALLOCATABLE ::  attributes       !< list of attributes
     END TYPE variable_type
 
     TYPE dimension_type
-       CHARACTER(LEN=charlen)                     ::  data_type = ''        !< data type
-       CHARACTER(LEN=charlen)                     ::  name                  !< dimension name
-       INTEGER                                    ::  id = no_id            !< dimension id within file
-       INTEGER                                    ::  length                !< length of dimension
-       INTEGER                                    ::  length_mask           !< length of masked dimension
-       INTEGER                                    ::  variable_id = no_id   !< associated variable id within file
-       LOGICAL                                    ::  is_masked = .FALSE.   !< true if masked
+       CHARACTER(LEN=charlen) ::  data_type = ''                            !< data type
+       CHARACTER(LEN=charlen) ::  name                                      !< dimension name
+       INTEGER                ::  id = no_id                                !< dimension id within file
+       INTEGER                ::  length                                    !< length of dimension
+       INTEGER                ::  length_mask                               !< length of masked dimension
+       INTEGER                ::  variable_id = no_id                       !< associated variable id within file
+       LOGICAL                ::  is_masked = .FALSE.                       !< true if masked
+       LOGICAL                ::  write_only_by_master_rank = .FALSE.       !< true if only master rank shall write variable
        INTEGER,         DIMENSION(2)              ::  bounds                !< lower and upper bound of dimension
        INTEGER,         DIMENSION(:), ALLOCATABLE ::  masked_indices        !< list of masked indices of dimension
@@ -365,4 +371,6 @@
 !> given which is then used to fill the entire dimension.
 !> An optional mask can be given to mask limited dimensions.
+!> Per default, a dimension is written to file only by the output master rank. However, this
+!> behaviour can be changed via the optional parameter 'write_only_by_master_rank'.
 !> Example call:
 !>   - fixed dimension with 100 entries (values known):
@@ -382,5 +390,15 @@
 !>                             output_type='real32', bounds=(/1/), &
 !>                             values_real32=(/fill_value/) )
+!>   - dimension values must be written by all MPI ranks later
+!>     (e.g. the master output rank does not know all dimension values):
+!>       status = dom_def_dim( file_name='my_output_file_name', dimension_name='my_dimension', &
+!>                             output_type='real32', bounds=(/1,100/), &
+!>                             values_real32=(/fill_value/), write_only_by_master_rank = .FALSE. )
 !>
+!> @note The optional argument 'write_only_by_master_rank' is set true by default to reduce the
+!>       number of file accesses. If dimension values must, however, be written by all MPI ranks
+!>       (e.g. each rank only knows parts of the values), 'write_only_by_master_rank' must be set
+!>       false to allow each rank to write values to the file for this dimension.
+!>       Values must be written after definition stage via calling dom_write_var.
 !> @todo Convert given values into selected output_type.
 !--------------------------------------------------------------------------------------------------!
@@ -388,5 +406,5 @@
                        values_int8, values_int16, values_int32, values_intwp,                      &
                        values_real32, values_real64, values_realwp,                                &
-                       mask )                                                                      &
+                       mask, write_only_by_master_rank )                                           &
              RESULT( return_value )
 
@@ -401,18 +419,20 @@
     INTEGER ::  i             !< loop index
     INTEGER ::  j             !< loop index
-    INTEGER ::  ndims = 0     !< number of dimensions in file
+    INTEGER ::  ndims         !< number of dimensions in file
     INTEGER ::  return_value  !< return value
 
-    INTEGER,         DIMENSION(:), INTENT(IN)           ::  bounds         !< lower and upper bound of dimension variable
-    INTEGER(KIND=1), DIMENSION(:), INTENT(IN), OPTIONAL ::  values_int8    !< values of dimension
-    INTEGER(KIND=2), DIMENSION(:), INTENT(IN), OPTIONAL ::  values_int16   !< values of dimension
-    INTEGER(KIND=4), DIMENSION(:), INTENT(IN), OPTIONAL ::  values_int32   !< values of dimension
-    INTEGER(iwp),    DIMENSION(:), INTENT(IN), OPTIONAL ::  values_intwp   !< values of dimension
-
-    LOGICAL,         DIMENSION(:), INTENT(IN), OPTIONAL ::  mask           !< mask of dimesion
-
-    REAL(KIND=4),    DIMENSION(:), INTENT(IN), OPTIONAL ::  values_real32  !< values of dimension
-    REAL(KIND=8),    DIMENSION(:), INTENT(IN), OPTIONAL ::  values_real64  !< values of dimension
-    REAL(wp),        DIMENSION(:), INTENT(IN), OPTIONAL ::  values_realwp  !< values of dimension
+    INTEGER,         DIMENSION(:), INTENT(IN)           ::  bounds        !< lower and upper bound of dimension variable
+    INTEGER(KIND=1), DIMENSION(:), INTENT(IN), OPTIONAL ::  values_int8   !< values of dimension
+    INTEGER(KIND=2), DIMENSION(:), INTENT(IN), OPTIONAL ::  values_int16  !< values of dimension
+    INTEGER(KIND=4), DIMENSION(:), INTENT(IN), OPTIONAL ::  values_int32  !< values of dimension
+    INTEGER(iwp),    DIMENSION(:), INTENT(IN), OPTIONAL ::  values_intwp  !< values of dimension
+
+    LOGICAL, INTENT(IN), OPTIONAL ::  write_only_by_master_rank  !< true if only master rank shall write this variable
+
+    LOGICAL, DIMENSION(:), INTENT(IN), OPTIONAL ::  mask  !< mask of dimesion
+
+    REAL(KIND=4), DIMENSION(:), INTENT(IN), OPTIONAL ::  values_real32  !< values of dimension
+    REAL(KIND=8), DIMENSION(:), INTENT(IN), OPTIONAL ::  values_real64  !< values of dimension
+    REAL(wp),     DIMENSION(:), INTENT(IN), OPTIONAL ::  values_realwp  !< values of dimension
 
     TYPE(dimension_type)                            ::  dimension       !< new dimension
@@ -421,4 +441,5 @@
 
     return_value = 0
+    ndims = 0
 
     CALL internal_message( 'debug', routine_name //                                                &
@@ -429,4 +450,10 @@
     dimension%name      = TRIM( dimension_name )
     dimension%data_type = TRIM( output_type )
+
+    IF ( PRESENT( write_only_by_master_rank ) )  THEN
+       dimension%write_only_by_master_rank = write_only_by_master_rank
+    ELSE
+       dimension%write_only_by_master_rank = .TRUE.
+    ENDIF
 !
 !-- Check dimension bounds and allocate dimension according to bounds
@@ -692,8 +719,8 @@
                          return_value = 1
                          CALL internal_message( 'error', routine_name //                           &
-                                        ': file already has a variable of this name defined. ' //  &
-                                        'Defining a dimension of the same name is not allowed ' // &
-                                        '(dimension "' // TRIM( dimension_name ) //                &
-                                       '", file "' // TRIM( file_name ) // '")!' )
+                                 ': file already has a variable of this name defined. ' //         &
+                                 'Defining a dimension of the same name is not allowed ' //        &
+                                 '(dimension "' // TRIM( dimension_name ) //                       &
+                                 '", file "' // TRIM( file_name ) // '")!' )
                          EXIT
                       ENDIF
@@ -754,7 +781,4 @@
 ! ------------
 !> Add variable to database.
-!> If a variable is identical for each MPI rank, the optional argument 'is_global' should be set to
-!> .TRUE. This flags the variable to be a global variable and is later only written once by the
-!> master output rank.
 !> Example call:
 !>   dom_def_var( file_name =  'my_output_file_name', &
@@ -774,6 +798,14 @@
 !>       or
 !>          ALLOCATE( u(<z>,<y>,<x>) )
-!--------------------------------------------------------------------------------------------------!
- FUNCTION dom_def_var( file_name, variable_name, dimension_names, output_type, is_global )         &
+!> @note The optional argument 'write_only_by_master_rank' can be used to reduce the number of file
+!>       accesses. If a variable is identical on each MPI rank, setting 'write_only_by_master_rank'
+!>       allows the underlying output modules to skip the write command if possible for MPI ranks
+!>       other than the master output rank.
+!>       As restrictions may apply for different output modules, it might be possible that this
+!>       option is ignored internally. Hence, all MPI ranks must still participate in the
+!>       dom_write_var calls in any case.
+!--------------------------------------------------------------------------------------------------!
+ FUNCTION dom_def_var( file_name, variable_name, dimension_names, output_type,                     &
+                       write_only_by_master_rank )                                                 &
              RESULT( return_value )
 
@@ -792,6 +824,6 @@
     INTEGER ::  return_value  !< return value
 
-    LOGICAL                       ::  found      !< true if requested dimension is defined in file
-    LOGICAL, INTENT(IN), OPTIONAL ::  is_global  !< true if variable is global (same on all PE)
+    LOGICAL                       ::  found                      !< true if requested dimension is defined in file
+    LOGICAL, INTENT(IN), OPTIONAL ::  write_only_by_master_rank  !< true if only master rank shall write this variable
 
     TYPE(variable_type)                            ::  variable       !< new variable
@@ -815,8 +847,8 @@
     variable%data_type = TRIM( output_type )
 
-    IF ( PRESENT( is_global ) )  THEN
-       variable%is_global = is_global
+    IF ( PRESENT( write_only_by_master_rank ) )  THEN
+       variable%write_only_by_master_rank = write_only_by_master_rank
     ELSE
-       variable%is_global = .FALSE.
+       variable%write_only_by_master_rank = .FALSE.
     ENDIF
 !
@@ -830,7 +862,7 @@
              return_value = 1
              CALL internal_message( 'error', routine_name //                                       &
-                          ': file already initialized. No further variable definition allowed ' // &
-                          '(variable "' // TRIM( variable_name ) //                                &
-                          '", file "' // TRIM( file_name ) // '")!' )
+                     ': file already initialized. No further variable definition allowed ' //      &
+                     '(variable "' // TRIM( variable_name ) //                                     &
+                     '", file "' // TRIM( file_name ) // '")!' )
              EXIT
 
@@ -842,8 +874,8 @@
                    return_value = 1
                    CALL internal_message( 'error', routine_name //                                 &
-                                        ': file already has a dimension of this name defined. ' // &
-                                        'Defining a variable of the same name is not allowed ' //  &
-                                        '(variable "' // TRIM( variable_name ) //                  &
-                                        '", file "' // TRIM( file_name ) // '")!' )
+                           ': file already has a dimension of this name defined. ' //              &
+                           'Defining a variable of the same name is not allowed ' //               &
+                           '(variable "' // TRIM( variable_name ) //                               &
+                           '", file "' // TRIM( file_name ) // '")!' )
                    EXIT
                 ENDIF
@@ -863,8 +895,8 @@
                       return_value = 1
                       CALL internal_message( 'error', routine_name //                              &
-                                 ': required dimension "'// TRIM( variable%dimension_names(i) ) // &
-                                 '" for variable is not defined ' //                               &
-                                 '(variable "' // TRIM( variable_name ) //                         &
-                                 '", file "' // TRIM( file_name ) // '")!' )
+                              ': required dimension "'//  TRIM( variable%dimension_names(i) ) //   &
+                              '" for variable is not defined ' //                                  &
+                              '(variable "' // TRIM( variable_name ) //                            &
+                              '", file "' // TRIM( file_name ) // '")!' )
                       EXIT
                    ENDIF
@@ -976,6 +1008,6 @@
     INTEGER ::  return_value  !< return value
 
+    LOGICAL, INTENT(IN), OPTIONAL ::  append           !< if true, append value to existing value
     LOGICAL                       ::  append_internal  !< same as 'append'
-    LOGICAL, INTENT(IN), OPTIONAL ::  append           !< if true, append value to existing value
 
     TYPE(attribute_type) ::  attribute  !< new attribute
@@ -1039,6 +1071,6 @@
     INTEGER ::  return_value  !< return value
 
+    LOGICAL, INTENT(IN), OPTIONAL ::  append           !< if true, append value to existing value
     LOGICAL                       ::  append_internal  !< same as 'append'
-    LOGICAL, INTENT(IN), OPTIONAL ::  append           !< if true, append value to existing value
 
     TYPE(attribute_type) ::  attribute  !< new attribute
@@ -1111,6 +1143,6 @@
     INTEGER ::  return_value  !< return value
 
+    LOGICAL, INTENT(IN), OPTIONAL ::  append           !< if true, append value to existing value
     LOGICAL                       ::  append_internal  !< same as 'append'
-    LOGICAL, INTENT(IN), OPTIONAL ::  append           !< if true, append value to existing value
 
     TYPE(attribute_type) ::  attribute  !< new attribute
@@ -1174,5 +1206,4 @@
     CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_def_att_int32'  !< name of routine
 
-
     CHARACTER(LEN=*),      INTENT(IN)           ::  attribute_name          !< name of attribute
     CHARACTER(LEN=*),      INTENT(IN)           ::  file_name               !< name of file
@@ -1184,6 +1215,6 @@
     INTEGER ::  return_value  !< return value
 
+    LOGICAL, INTENT(IN), OPTIONAL ::  append           !< if true, append value to existing value
     LOGICAL                       ::  append_internal  !< same as 'append'
-    LOGICAL, INTENT(IN), OPTIONAL ::  append           !< if true, append value to existing value
 
     TYPE(attribute_type) ::  attribute  !< new attribute
@@ -1254,6 +1285,6 @@
     INTEGER ::  return_value  !< return value
 
+    LOGICAL, INTENT(IN), OPTIONAL ::  append           !< if true, append value to existing value
     LOGICAL                       ::  append_internal  !< same as 'append'
-    LOGICAL, INTENT(IN), OPTIONAL ::  append           !< if true, append value to existing value
 
     REAL(KIND=4), INTENT(IN) ::  value  !< attribute value
@@ -1326,6 +1357,6 @@
     INTEGER ::  return_value  !< return value
 
+    LOGICAL, INTENT(IN), OPTIONAL ::  append           !< if true, append value to existing value
     LOGICAL                       ::  append_internal  !< same as 'append'
-    LOGICAL, INTENT(IN), OPTIONAL ::  append           !< if true, append value to existing value
 
     REAL(KIND=8), INTENT(IN) ::  value  !< attribute value
@@ -1584,5 +1615,4 @@
     INTEGER, DIMENSION(:),   INTENT(IN)  ::  bounds_end             !< end index per dimension of variable
     INTEGER, DIMENSION(:),   INTENT(IN)  ::  bounds_start           !< start index per dimension of variable
-
     INTEGER, DIMENSION(:),   ALLOCATABLE ::  bounds_origin          !< first index of each dimension
     INTEGER, DIMENSION(:),   ALLOCATABLE ::  bounds_start_internal  !< start index per dim. for output after masking
@@ -1590,6 +1620,6 @@
     INTEGER, DIMENSION(:,:), ALLOCATABLE ::  masked_indices         !< list containing all output indices along a dimension
 
-    LOGICAL ::  do_output  !< true if any data lies within given range of masked dimension
-    LOGICAL ::  is_global  !< true if variable is global
+    LOGICAL ::  do_output                  !< true if any data lies within given range of masked dimension
+    LOGICAL ::  write_only_by_master_rank  !< true if only master rank shall write variable
 
     INTEGER(KIND=1), POINTER, INTENT(IN), OPTIONAL                   ::  values_int8_0d             !< output variable
@@ -1687,5 +1717,5 @@
 !-- Search for variable within file
     CALL find_var_in_file( file_name, variable_name, file_format, file_id, variable_id,            &
-                           is_global, dimension_list, return_value=return_value  )
+                           write_only_by_master_rank, dimension_list, return_value=return_value  )
 
     IF ( return_value == 0 )  THEN
@@ -1740,5 +1770,5 @@
 !
 !--    Mask and resort variable
-!--    character output
+!--    Character output
        IF ( PRESENT( values_char_0d ) )  THEN
           values_char_0d_pointer => values_char_0d
@@ -1845,5 +1875,5 @@
                       values_int8_3d_resorted(i,j,k) = values_int8_3d(masked_indices(3,k),         &
                                                                       masked_indices(2,j),         &
-                                                                      masked_indices(1,i)  )
+                                                                      masked_indices(1,i))
                    ENDDO
                 ENDDO
